/* -------------------------------------------------------------------	*/
/* Copyright (C) 2008 Robert R. Bruner.  All rights reserved.		*/
/* Contact the author at						*/
/*                    rrb@math.wayne.edu				*/
/*                    Dept of Mathematics				*/
/*                    Wayne State University				*/
/*                    Detroit, Michigan  48202				*/
/*                    USA						*/
/*									*/
/* Version 1.8								*/
/* -------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>

#include <errors.h>

main(argc,argv) int argc; char *argv[];

{

int n,lo,hi,i,g;
FILE *Out;
char *filename="Def";

/* -------------- check calling sequence -----------------------------  */
if ((argc != 3) && (argc != 4))
{
  fprintf(stderr,
    "\nUsage: makeCP <lo> <hi> [<file>]\n");
  fprintf(stderr,
    "  writes a Def file for stunted complex projective space with cells\n");
  fprintf(stderr,
    "  in dimensions 2*<lo> to 2*<hi> in <file> if specified, or Def\n");
  fprintf(stderr,
    "  if no file is specified.\n\n");
  exit(1);
}

/* ------------------ get range --------------------------------------- */

sscanf(argv[1],"%d",&lo);
sscanf(argv[2],"%d",&hi);

/* ------------------ open Def --------------------------------------- */

if (argc == 4) filename = argv[3];
if ((Out = fopen(filename,"w")) == NULL)
{
  fprintf(stderr,"\nCannot open %s to write\n\n",filename);
  exit(1);
}

/* ------------------ Now write header  ------------------------------ */

fprintf(Out,"%d\n",hi-lo+1);

for (i=lo; i <= hi; i++)
{
  if (!(i & 15)) fprintf(Out,"\n");
  fprintf(Out,"%d ",2*i);
}
fprintf(Out,"\n\n");

/* ------------------ write Sq^n(g)   ------------------------------ */

for (g=lo; g < hi; g++)
for (n=1; n <= hi-g; n++)
if (n == (n&g))
  fprintf(Out,"%d %d 1 %d\n",g-lo,2*n,n+g-lo);

/* --------------------------- Done   ------------------------------ */


fclose(Out);
   
}

