/* -------------------------------------------------------------------	*/
/* Copyright (C) 2002 Robert R. Bruner.  All rights reserved.		*/
/* Contact the author at						*/
/*                    rrb@math.wayne.edu				*/
/*                    Dept of Mathematics				*/
/*                    Wayne State University				*/
/*                    Detroit, Michigan  48202				*/
/*                    USA						*/
/*									*/
/* Version 1.7								*/
/* -------------------------------------------------------------------- */

#ifndef N_ALG
#define N_ALG 7
#endif


#ifndef STEEN_DONE

#include <structur.h>

typedef int Internal_Op[N_ALG];

/* WARNING: Mult will stay within the subalgebra defined by N_ALG (see  */
/* the comments at the start of Mult) but none of the other routines    */
/* are that smart at present.  EG when N_ALG == 2, the algebra is 8     */
/* dimensional, and has, for example, only one element of degree 4,     */
/* namely (1,1).  However, Seqno, first_op, advance_op, etc will all    */
/* act as if (4) were also a legal operation.                           */

#define dimA(n) d(N_ALG,n)
extern         int    degree( /* Internal_Op Op */ );
extern  void          fprint_op(/* FILE *fp; Internal_Op Op */);
extern  void          print_op (/*Internal_Op Op*/);
extern  int           first_op (/*Internal_Op Op,int deg*/);
extern  int           next_op(/*Internal_Op Op, int seqno*/);
extern  int           advance_op (/*Internal_Op Op*/);
extern  int           adv_op (/*Internal_Op Op,int k*/);
extern  unsigned      d(/* unsigned k; int n; */);
extern  unsigned int  Seqno (/*Internal_Op Op*/);
extern  int           mult (/*Internal_Op R,Internal_Op S,TERM *x*/);
extern  int           first_Coproduct(/* Internal_Op Op,Op1,Op2 */);
extern  int           next_Coproduct(/* Internal_Op Op,Op1,Op2 */);
extern  int           halve(/* Internal_Op Op, hOp */);
#define STEEN_DONE


#endif
