/* -------------------------------------------------------------------	*/
/* Copyright (C) 2008 Robert R. Bruner.  All rights reserved.		*/
/* Contact the author at						*/
/*                    rrb@math.wayne.edu				*/
/*                    Dept of Mathematics				*/
/*                    Wayne State University				*/
/*                    Detroit, Michigan  48202				*/
/*                    USA						*/
/*									*/
/* Version 1.8								*/
/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>

#include <errors.h>
#include <tensor.h>
#include <steen.h>


typedef struct LIST { int item;
               struct LIST *next; }  LIST;


main(argc,argv) int argc; char *argv[];

{

int i,s,s0,g,g0,g1,n;
int count,maxstem, minstem;
LIST ***Num;
Tensor_shape  *shape;
FILE *Lines;
LIST ****his;
LIST *temp, *it;

char message[100];



/* ------------------ get shape  ----------------------------------- */

shape = read_shape(-1);

maxstem = minstem = shape->deg[0][0];
for (s=0; s<=shape->s; s++)
 for (g=0; g<shape->numgen[s]; g++)
 { if (maxstem < shape->deg[s][g]-s) maxstem = shape->deg[s][g]-s;
   if (minstem > shape->deg[s][g]-s) minstem = shape->deg[s][g]-s;
 }

Num = (LIST ***) malloc(((++maxstem)-minstem)*sizeof(LIST **));
Num -= minstem;
		/*      Now Num[minstem] through Num[maxstem-1] exist	*/
for (n=minstem; n < maxstem; n++)
{  Num[n] = (LIST  **) malloc((1+shape->s)*sizeof(LIST *));
   for (s=0; s<= shape->s; s++) Num[n][s] = NULL;
}

for (s=0; s<=shape->s; s++)
 for (g=0; g<shape->numgen[s]; g++)
{
   n = shape->deg[s][g]-s;
   temp = (LIST *) malloc(sizeof(LIST));
   temp->item = g;
   temp->next = Num[n][s];
   Num[n][s] = temp;
} 


/* ------------------ Now create his data structure  ------------------ */

his = (LIST ****) malloc((1+shape->s)*sizeof(LIST ***));
for (s=0; s<=shape->s; s++)
{ his[s] = (LIST ***) malloc((shape->numgen[s])*sizeof(LIST **));
  for (g=0; g<shape->numgen[s]; g++)
  { his[s][g] = (LIST **) malloc((1+N_ALG)*sizeof(LIST *));
    for (i=0; i<= N_ALG; i++)
      his[s][g][i] = NULL;
}
}


/* ------------------ Now read his  ----------------------------------- */


if ((Lines = fopen("lines","r")) == NULL)
{  sprintf(message,"\nCannot open lines files.\n");
   terminate(message,BAD_WORKFILE);
}

while (EOF != fscanf(Lines,"%d %d %d %d %d",&s,&g,&s0,&g0,&count))
{ 
  for (i=0; i<count; i++)
  { fscanf(Lines,"%d",&g1);
    temp = (LIST *) malloc(sizeof(LIST));
    temp->item = g;
    temp->next = his[s-1][g1][g0];
    his[s-1][g1][g0] = temp;

  }
}

fclose(Lines);

/* -------------------- Now print out all stems -------------- */

for (n=minstem; n<maxstem; n++)
{
  printf("\nStem %d ------------------------\n\n",n);
  for (s=0; s<=shape->s; s++)
    if (Num[n][s] != NULL)
  {
    printf("Filtration %d:\n\n",s);
    for (temp=Num[n][s]; temp != NULL; temp=temp->next)
    {
       g = temp->item;
       printf("%3d%4d%5d: ",s,n,g);
       for (i=0; i<=N_ALG; i++)
         if (his[s][g][i] != NULL)
         {
           printf(" h%d  *%4d =",i,g);
           for (it=his[s][g][i]; it != NULL; it = it->next)
           {
             printf(" %d",it->item);
           }
           printf("\n              ");
         }
       printf("\n\n");
    }
  }

}

printf("\n------------------ END ---------------------\n\n");
   
return(0);

}

