/* -------------------------------------------------------------------	*/
/* Copyright (C) 2015 Robert R. Bruner.  All rights reserved.		*/
/* Contact the author at						*/
/*                    rrb@math.wayne.edu				*/
/*                    Dept of Mathematics				*/
/*                    Wayne State University				*/
/*                    Detroit, Michigan  48202				*/
/*                    USA						*/
/*									*/
/* Version 1.9								*/
/* -------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>

#include <errors.h>
#include <tensor.h>
#include <setup.h>

main(argc,argv) int argc; char *argv[];
{

int s,g;
Tensor_shape   *shape;
FILE  *Shape, *all;
char message[100];


/* -------------- check calling sequence -----------------------------  */
if ((argc != 3))
{
  printf("\nUsage: missing shape all\n\n");
  printf("    reads the shape file to determine the number of\n");
  printf("    generators in each degree, then reads all, a list\n");
  printf("    of pairs s,g to determine which generators are\n");
  printf("    not in the list <all>, which it reports.\n");
  exit(1);
}

/* ------------------ get shape  ----------------------------------- */

shape = fread_shape(argv[1],-1);

for (s=0; s<=shape->s; s++)
 for (g=0; g<shape->numgen[s]; g++)
 { shape->deg[s][g] = 0;
 }

/* ------------------ Read gens  ----------------------------------- */

if ((all = fopen(argv[2],"r")) == NULL)
{  sprintf(message,"\nCannot open file: %s\n",argv[2]);
   terminate(message,BAD_WORKFILE);
}

while (EOF != fscanf(all,"%d %d",&s,&g))
  shape->deg[s][g] = 1;

/* ------------------ Now report missing gens  ----------------------- */


for (s=0; s<=shape->s; s++)
 for (g=0; g<shape->numgen[s]; g++)
  if (!shape->deg[s][g])
     printf("%d %d\n",s,g);
   
}

